#include"filemenu.h"
#include"mouse.h"
#include"calc.h"
#include"indi.h"
//file_menu--------------------------------

extern file_menu fmenu;
extern mouse ms;
extern calculator calc;
extern indicator indi;

file_menu::file_menu()
{
 strcpy(name,"");
 wide=strlen(name)*8;
 hpos=pos+10;
 active=0;
 strcpy(fname,"NONAME.mk");
 curpath[0]='\\';
 getcurdir(0,curpath+1);
 DIR.setpos(pos+20,30,pos+400,40);
 DIR.set(curpath);
 OPEN.setpos(pos+40,75,pos+120,95);
 OPEN.set("");
 SAVE.setpos(pos+40,115,pos+120,135);
 SAVE.set("࠭");
 EXIT.setpos(pos+40,220,pos+120,240);
 EXIT.set("室");
 LIST.setpos(pos+150,55,pos+350,301);
 FUP.setpos(pos+351,55,pos+365,178);
 FUP.set("");
 FDOWN.setpos(pos+351,179,pos+365,301);
 FDOWN.set("");
 FIL.setpos(pos+70,305,pos+270,323);
 FIL.set(fname,2);
 strcpy(tags[0],"[PROGRAM]\n");
 strcpy(tags[1],"[STACK]\n");
 strcpy(tags[2],"[REGISTERS]\n");
 quit=0;
 close();
}

void file_menu::open()
{
 clear();
 head(1);
 ms.off();
 settextstyle(0,0,0);
 setcolor(120);
 settextjustify(0,2);
 outtextxy(pos+22,20,"⠫:");
 outtextxy(pos+151,46,"᮪ 䠩:");
 outtextxy(pos+22,310,":");
 ms.on();
 DIR.open();
 OPEN.open();
 SAVE.open();
 EXIT.open();
 LIST.open();
 FUP.open();
 FDOWN.open();
 FIL.open();
 refresh();
 //ms.on();
}

void file_menu::refresh()
{
 ms.off();
 DIR.refresh();
 OPEN.refresh();
 SAVE.refresh();
 EXIT.refresh();
 LIST.refresh();
 FUP.refresh();
 FDOWN.refresh();
 FIL.refresh();
 ms.on();
}

void file_menu::click()
{
 if(OPEN.pressed())openfile(fname);
 if(SAVE.pressed())savefile();
 if(EXIT.pressed())quit=1;;
 LIST.click();
 if(FUP.pressed())LIST.up();
 if(FDOWN.pressed())LIST.down();
 FIL.click();
}

// ᯨ᪠ 䠩
filedit::filedit()
{
 nline=30;
 reread();
 fresh=1;
 lock=0;
}

void filedit::up()
{
 begin-=(nline>>1);
 if(begin<0)begin=0;
 show();
 paint();
}

void filedit::down()
{
 begin+=(nline>>1);
 if(begin+nline>flist.num())begin=flist.num()-nline;
 if(begin<0)begin=0;
 show();
 paint();
}

void filedit::edit()
{
 if(!lock)
 {
 int pos;
 pos=(menu::my-y0-3)/8;
 int i;
 if(begin+pos<=flist.num())
 {
 flist.reset();
 for(i=0;i<begin+pos;i++)flist.next();
 listitem L;
 L=flist.get();
 if(!isdigit(L.date[0]))
 {
  chdir(L.name);
  getcurdir(0,fmenu.curpath+1);
  reread();
  fresh=1;
  fmenu.DIR.fresh=1;
  lock=1;
 }
 else
 {
  strcpy(fmenu.fname,L.name);
  fmenu.FIL.fresh=1;
 }
 fmenu.fresh=1;
 }
 }
}

void filedit::paint(int mode)
{
 int i,ypos;
 listitem L;
 settextstyle(0,0,0);
 setcolor(10);
 settextjustify(0,2);
 flist.reset();
 if(flist.num()>0)
 {
 for(i=0;i<begin;i++)flist.next();
 for(i=0;i<nline;i++)
 {
	ypos=y0+3+i*8;
	L=flist.get();
	outtextxy(x0+3,ypos,L.name);
  outtextxy(x0+115,ypos,L.date);
	if(!flist.next())break;
 }
 }
 lock=0;
}

void filedit::reread()
{
 ffblk F;
 listitem L;
 //strcpy(path,fmenu.curpath);
 //strcat(path,"\*.*");
 flist.destroy();
 char str1[16],str2[16];
 if(!findfirst("*.*",&F,FA_DIREC))
 {
 do
 {
  if(strcmp(F.ff_name,"."))
  {
	strcpy(L.name,F.ff_name);
  if(F.ff_attrib&FA_DIREC)
  {
   if(!strcmp(F.ff_name,".."))
    strcpy(L.date,"UP \x18");
   else
    strcpy(L.date,"DIR ->");
   flist.insert(L);
  }
  else
  {
  if(strstr(F.ff_name,".MK"))
  {
  itoa(F.ff_fdate&0x001f,str2,10);
  strcpy(str1,str2);
  strcat(str1,".");
  itoa((F.ff_fdate&0x01e0)>>5,str2,10);
  strcat(str1,str2);
  strcat(str1,".");
  itoa(((F.ff_fdate&0xfe00)>>9)+1980,str2,10);
  strcat(str1,str2);
  //itoa(F.ff_fdate,str1,16);
  strcpy(L.date,str1);
  flist.insert(L);
  }
  }
  }
 }
 while(!findnext(&F));// ,  室
 }
}

int file_menu::savefile()
{
 FILE *F;
 F=fopen(fname,"wt");
 if(!F)return 0;
 fprintf(F,"%s",tags[0]);// ணࠬ
 int i;
 for(i=0;i<105;i++)
  fprintf(F,"%x\n",calc.prog[i]);
 fprintf(F,"%s",tags[1]);// ⥪
 for(i=0;i<5;i++)
  fprintf(F,"%g\n",calc.stack[i]);
 fprintf(F,"%s",tags[2]);// ॣ஢ 
 for(i=0;i<15;i++)
  fprintf(F,"%g\n",calc.mem[i]);
 fclose(F);
 LIST.reread();
 LIST.fresh=1;
 return 1;
}

int file_menu::openfile(const char *fn)
{
 FILE *F;
 F=fopen(fn,"rt");
 if(!F)
 {
  F=fopen(fn,"wt");
  fclose(F);
  calc.totreset();
  indi.refresh();
  LIST.reread();
  LIST.fresh=1;
  return 0;
 }
 char str[80];
 int i=-1,j;
 int tag=-1;
 for(j=0;j<3;j++)
 {
  tag=-1;
  do
  {
   fgets(str,80,F);
   for(i=0;i<3;i++)
    if(!strcmp(str,tags[i])){tag=i;break;}
  }
  while(tag==-1&&!feof(F));
  switch(tag)
  {
   case 0:
   for(i=0;i<105;i++)
   {
    fscanf(F,"%x",&calc.prog[i]);
    if(ferror(F))break;
   }
   break;
   case 1:
   for(i=0;i<5;i++)
   {
    fgets(str,80,F);
    calc.stack[i]=atof(str);
    if(ferror(F))break;
   }
   break;
   case 2:
   for(i=0;i<15;i++)
   {
    fgets(str,80,F);
    calc.mem[i]=atof(str);
    if(ferror(F))break;
   }
   break;
   default:
    fclose(F);
    return 0;
  }
 }
 fclose(F);
 calc.numindi();
 indi.refresh();
 return 1;
}