// 稭   ⥬ 
#ifndef MENUH
#define MENUH

#include<graphics.h>
#include<dir.h>
#include<string.h>
#include<stdio.h>


class form//   
{
 protected:
  int x0,x1,y0,y1;//न
 public:
  form(){x0=x1=y0=y1=0;fresh=1;};
  void setpos(int,int,int,int);
  virtual void open();
  virtual void close();
  int fresh;//  
};

class viewer: public form// - 뢠
{
  const double *num;// 뢠
  int size;       //ࠧ 
 public:
  viewer(){num=0;size=0;};
  void set(int,int,int,int,double*,int S=0);//  ࠬ
  void refresh();
};

class textview: public form
{
 protected:
  char *txt;
  int size;
  int len;
 public:
  textview(){txt=0;size=0;};
  void set(char *c,int s=0);
  void refresh();
};

class textedit: public textview
{
 public:
  void click();
  void edit();
};

class light: public form//-窠
{
 protected:
  char text[5];
  char col;
  int* on;
 public:
  light(char* txt,char c=255){set(txt,c);};
	light(){text[0]=0;col=255;};
  void set(char* txt,char col,int* p=0);
	void refresh();
};

class advlight: public light//  ࠧ묨 ﬨ
{
 protected:
  char text2[5];
 public:
  advlight(char* txt,char* txt2,char c=255){set(txt,txt2,c);};
  advlight(){text[0]=0;text2[0]=0;col=255;};
  void set(char* txt,char* txt2,char col,int* p=0);
  void refresh();
};

class button:public form  // 
{
 protected:
  char text[20];
  void show(int);//ᮢ ⮩  饭
	int press;
	char clrcol;//梥,  
	void init();
 public:
	void open();
	int pressed();//஢  ⨥  ᮢ
	void set(char *text,char clrcol=0);
	void refresh();
	button(char *text){set(text);};
	button(){text[0]=0;};
};

class editor:public form //⮢ ।
{
 protected:
	virtual void edit()=0;//।஢ 
	virtual void paint(int mode=0)=0;
	void show();
 public:
	editor();
	virtual void up()=0;  //ᤢ  
	virtual void down()=0;//
	void init();
	void open();
	void click();
	void refresh();
};

struct listitem// ᯨ᪠
{
 private:
 listitem *next;
 friend list;
 public:
 char name[16];
 char date[16];
};

class list//c᮪    ᮧ 䠩
{
 private:
	listitem *begin,*cur;
	int N;//᫮ ⮢
 public:
	list();
	int next();// ᫥騩 
	void reset();//⠭  砫
	listitem get();// 
	void insert(listitem&);//⠢ 
	void destroy();// ᯨ᮪
	int num(){return N;};
	~list();
};

class menu    // 
{
 protected:
 menu();
 void clear();   //⪠ 㦭   ࠭
 int hpos,wide; // 
 void head(int);// 
 char name[15];// 
 static int pos;// 
 //void close(int);
 virtual void refresh()=0;
 int active;
 friend button;
 public:
 void check();//஢ઠ  ४祭
 virtual void open()=0;
 virtual void click()=0;
 void close();
 int fresh;
 static int mx,my;//
};


#endif