//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
#pragma resource "bitmaps.res"

TForm1 *Form1;
TShortCut HotKeys[30][2]= // -
{{'Q',0},
 {'W',0},
 {'E',0},
 {'R',0},
 {'T',0},
 {'A',0},
 {'S',0},
 {'D',0},
 {'F',0},
 {'G',0},
 {103,55},
 {104,56},
 {105,57},
 {109,0},
 {111,0},
 {100,52},
 {101,53},
 {102,54},
 {107,0},
 {106,0},
 {97,49},
 {98,50},
 {99,51},
 {220,0},
 {13,0},
 {96,48},
 {110,190},
 {189,0},
 {187,0},
 {8,46}};
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
 Application->OnIdle=AppIdle;
 ClientWidth=BasePanel->Width; // 
 int i,j;
 // 
 for(j=0;j<6;j++)    //  
  for(i=0;i<5;i++)
  {
   TSpeedButton *CurBtn;
   CurBtn=new TSpeedButton(this);   //  
   if(!CurBtn)break;
   CalcBtns[i][j]=CurBtn;
   CurBtn->Parent=MainPanel;
   CurBtn->Left=10+i*40;
   CurBtn->Top=100+j*40;
   CurBtn->Width=32;          //
   CurBtn->Height=22;
   CurBtn->Tag=j*5+i;
   CurBtn->AllowAllUp=true;
   CurBtn->OnClick=calc.key;
   CurBtn->OnMouseMove=BtnMouseMove;
   AnsiString ResCoord=IntToStr(i)+IntToStr(j);
   CurBtn->Glyph->LoadFromResourceName((int)HInstance,(AnsiString)"M"+ResCoord); //  ( )
   TImage *CurImg;
   if(FindResource(HInstance,((AnsiString)"Y"+ResCoord).c_str(),RT_BITMAP))//   
   {
    CurImg=new TImage(Form1);
    if(!CurImg)break;
    CurImg->Parent=MainPanel;
    CurImg->AutoSize=true;
    if(FindResource(HInstance,((AnsiString)"B"+ResCoord).c_str(),RT_BITMAP))//   
    {
     TImage *CurImg2;
     CurImg2=new TImage(Form1); // 
     if(!CurImg2)break;
     CurImg2->Parent=MainPanel;
     CurImg2->AutoSize=true;
     CurImg2->Left=24+i*40;     //
     CurImg2->Top=89+j*40;
     CurImg2->Transparent=true;
     CurImg2->Picture->Bitmap->LoadFromResourceName((int)HInstance,(AnsiString)"B"+ResCoord);// 
     CurImg->Left=6+i*40;    //,      
     CurImg->Top=89+j*40;
     Blue[i][j]=CurImg2;
    }
    else
    {
     CurImg->Left=15+i*40; //   
     CurImg->Top=89+j*40;
     Blue[i][j]=NULL;
    }
    CurImg->Transparent=true;
    CurImg->Picture->Bitmap->LoadFromResourceName((int)HInstance,(AnsiString)"Y"+ResCoord);//  
   }
   else
   {
    CurImg=NULL;
   }
   Yellow[i][j]=CurImg;
  }
  //   
 for(i=0;i<12;i++)
 {
  Indi[i]=new TSegIndi(this);//
  Indi[i]->Parent=IndiPanel;
  Indi[i]->Width=18;      //
  Indi[i]->Height=29;
  Indi[i]->Left=4+i*17;
  Indi[i]->Top=9;
  Indi[i]->OffPenColor=clBtnFace;//
  Indi[i]->OffBrushColor=(TColor)(ColorToRGB(clBtnFace)|0x000F0F0F);
  Indi[i]->OnPenColor=(TColor)(ColorToRGB(clActiveCaption)&0xFFF0F0F0);
  Indi[i]->OnBrushColor=clActiveCaption;
 }
 Indi[0]->ExSegments=Indi[0]->ExSegments>>segA>>segB>>segC>>segD>>segE>>segF>>segH;
 Indi[9]->ExSegments=Indi[0]->ExSegments;//  
 Indi[10]->ExSegments=Indi[10]->ExSegments>>segH;
 Indi[11]->ExSegments=Indi[10]->ExSegments;
 Indi[0]->Symbols->Add("G");// 
 Indi[0]->Symbols->Add("FED");
 Indi[0]->Symbols->Add("AFED");
 Indi[0]->Symbols->Add("AFE");
 Indi[0]->Symbols->Add("AFEDG");
 Indi[0]->Symbols->Add("AFEG");
 Indi[0]->Symbols->Add("");
 Indi[0]->Symbols->Add("");
 for(i=1;i<12;i++)           //  
  Indi[i]->Symbols=Indi[0]->Symbols;
 for(i=0;i<12;i++)       // 
  Indi[i]->SymbolIndex=16;
 Indi[1]->SymbolIndex=0;    //  - 
 Indi[1]->OnSegments=Indi[1]->OnSegments<<segH; // 
 //    .
 for(i=0;i<15;i++)
 {
  Mem[i]=new TEdit(this);
  Mem[i]->Parent=MemoTab;
  Mem[i]->AutoSize=false;
  Mem[i]->Height=17;
  Mem[i]->Left=24;
  Mem[i]->Top=115+i*16;
  Mem[i]->Text="0";
  Mem[i]->OnChange=MemChange;
  Mem[i]->Tag=i;
  Mem[i]->OnEnter=EnterEdit;
  Mem[i]->OnExit=ExitEdit;
 }
 // ""
 for(i=0;i<105;i++)
  ProgList->Items->Add(IntToStr(i));
 ProgList->ItemIndex=0;
 KeysComboBox->ItemIndex=0;  //  ,  
 Editing=false;
 FileName->Text=ExtractFileDir(Application->ExeName)+"\\MK61.mk";
 OpenButt->Click();
 FileName->Text="MK61.mk";
 CurFile->Caption=FileName->Text;
 HelpFile=fopen(ChangeFileExt(Application->ExeName,".hlp").c_str(),"rt");
 ShowHelp("[DEFAULT]");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CloseButtonClick(TObject *Sender)
{
 Close();  //    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MinimizeButtonClick(TObject *Sender)
{
 Application->Minimize();  //    _
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpPanelMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if(DblClicking)return;
 if(Button==mbLeft) //  ""
 {
  X4move=X;
  Y4move=Y;
  preX4move=0;
  preY4move=0;
  HDC hdc=GetDC(NULL);
  RECT Rect;
  Rect.left=Left;
  Rect.top=Top;
  Rect.right=Rect.left+ClientWidth;
  Rect.bottom=Rect.top+ClientHeight;
  DrawFocusRect(hdc,&Rect); // 
  ReleaseDC(NULL,hdc);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpPanelMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if(DblClicking)return;
 if(Shift.Contains(ssLeft))
 {
  //Left+=X-X4move;
  //Top+=Y-Y4move;
  HDC hdc=GetDC(NULL);
  RECT Rect;
  Rect.left=Left+preX4move;
  Rect.top=Top+preY4move;
  Rect.right=Rect.left+ClientWidth;
  Rect.bottom=Rect.top+ClientHeight;
  DrawFocusRect(hdc,&Rect); //  .
  Rect.left=Left-X4move+X;
  Rect.top=Top-Y4move+Y;
  Rect.right=Rect.left+ClientWidth;
  Rect.bottom=Rect.top+ClientHeight;
  DrawFocusRect(hdc,&Rect); // 
  ReleaseDC(NULL,hdc);
  preX4move=X-X4move;     // 
  preY4move=Y-Y4move;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpPanelMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if(DblClicking)
 {
  DblClicking=false;
  return;
 }
 if(Button==mbLeft)
 {
  HDC hdc=GetDC(NULL);
  RECT Rect;
  Rect.left=Left+preX4move;
  Rect.top=Top+preY4move;
  Rect.right=Rect.left+ClientWidth;
  Rect.bottom=Rect.top+ClientHeight;
  DrawFocusRect(hdc,&Rect); //  
  ReleaseDC(NULL,hdc);
  MoveWindow(Handle,Left+preX4move,Top+preY4move,Width,Height,true); // 
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuButtonClick(TObject *Sender)
{
 if(!MenuButton->Down)
 {
  MenuPanel->Hide();    // 
  ClientWidth=BasePanel->Width;      // 
 }
 else
 {
  ClientWidth+=MenuPanel->Width;   // 
  MenuPanel->Show();          //
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpPanelDblClick(TObject *Sender)
{
 //HDC hdc=GetDC(NULL);
 DblClicking=true;
 MenuButton->Down=!MenuButton->Down; //   "" ==  
 //DrawFocusRect(hdc,&Rect(Left,Top,Left+ClientWidth,Top+ClientHeight));
 MenuButtonClick(this);
 //DrawFocusRect(hdc,&Rect(Left,Top,Left+ClientWidth,Top+ClientHeight));
 //ReleaseDC(NULL,hdc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExitButtClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FreshMenu()
{
 Freshing=true;
 EditT->Text=FloatToStr(calc.stack[4]);
 EditZ->Text=FloatToStr(calc.stack[3]);
 EditY->Text=FloatToStr(calc.stack[2]);
 EditX->Text=FloatToStr(calc.stack[1]);
 EditX1->Text=FloatToStr(calc.stack[0]);
 int i;
 for(i=0;i<15;i++)
  Mem[i]->Text=FloatToStr(calc.mem[i]);
 ProgList->ItemIndex=calc.prgstep;
 if(calc.PRG)
 {
  ProgList->Invalidate();
  PRGLabel->Caption="";
 }
 else
  PRGLabel->Caption="";
 if(calc.F)
 {
  FKLabel->Font->Color=clYellow;
  FKLabel->Caption="F";
  FKLabel->Visible=true;
 }
 else if(calc.K)
 {
  FKLabel->Font->Color=clAqua;
  FKLabel->Caption="K";
  FKLabel->Visible=true;
 }
 else
 {
  FKLabel->Visible=false;
 }
 Freshing=false;
}
//---------------------------------------------------------
double __fastcall TForm1::Str2Float(AnsiString Str)
{
 double res=0;
 try
 {
  res=Str.ToDouble();
 }
 catch (...)
 {
  res=0;
 }
 return res;
}
//--------------------------------------------------------------
void __fastcall TForm1::EditTChange(TObject *Sender)
{
 if(Freshing)return;
 calc.stack[4]=Str2Float(EditT->Text);
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditZChange(TObject *Sender)
{
 if(Freshing)return;
 calc.stack[3]=Str2Float(EditZ->Text);
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditYChange(TObject *Sender)
{
 if(Freshing)return;
 calc.stack[2]=Str2Float(EditY->Text);
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditXChange(TObject *Sender)
{
 if(Freshing)return;
 calc.stack[1]=Str2Float(EditX->Text);
 calc.numindi();
 indi.refresh();
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditX1Change(TObject *Sender)
{
 if(Freshing)return;
 calc.stack[0]=Str2Float(EditX1->Text);
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MemChange(TObject* Sender)
{
 if(Freshing)return;
 TEdit* Edit=(TEdit*)Sender;
 calc.mem[Edit->Tag]=Str2Float(Edit->Text);
 File.saved=false;
}
//------------------------------------------------------------
void __fastcall TForm1::ProgListDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
 const int lx1=30,lx2=57,lx3=84,dy=5;
 if(State.Contains(odSelected))
 {
  ProgList->Canvas->Brush->Color=clHighlight;
  ProgList->Canvas->Font->Color=clHighlightText;
 }
 else
 {
  ProgList->Canvas->Brush->Color=ProgList->Color;
  ProgList->Canvas->Font->Color=clWindowText;
 }
 ProgList->Canvas->FillRect(Rect);
 ProgList->Canvas->TextOut(3,Rect.Top+2,ProgList->Items->Strings[Index]);
 ProgList->Canvas->TextOut(Rect.Right-18,Rect.Top+2,IntToHex(calc.prog[Index],2));
 int tmp,com,ypos;
 bool jmp;
 if(Index!=0&&((tmp=calc.prog[Index-1])==0x51||(tmp>=0x57&&tmp<=0x5e)||tmp==0x53))
	jmp=1;
 else jmp=0; //     ,    
 com=calc.prog[Index];
 ypos=Rect.Top;
 if(jmp)//    
 {
  PaintNum(com>>4,lx1,ypos);
  PaintNum(com%16,lx2,ypos);
  jmp=0;
 }
 else//
 switch(com)// 
 {
  case 0x00:PutImage(lx1,ypos,CalcBtns[0][5]->Glyph);break;
  case 0x01:PutImage(lx1,ypos,CalcBtns[0][4]->Glyph);break;
  case 0x02:PutImage(lx1,ypos,CalcBtns[1][4]->Glyph);break;
  case 0x03:PutImage(lx1,ypos,CalcBtns[2][4]->Glyph);break;
  case 0x04:PutImage(lx1,ypos,CalcBtns[0][3]->Glyph);break;
  case 0x05:PutImage(lx1,ypos,CalcBtns[1][3]->Glyph);break;
  case 0x06:PutImage(lx1,ypos,CalcBtns[2][3]->Glyph);break;
  case 0x07:PutImage(lx1,ypos,CalcBtns[0][2]->Glyph);break;
  case 0x08:PutImage(lx1,ypos,CalcBtns[1][2]->Glyph);break;
  case 0x09:PutImage(lx1,ypos,CalcBtns[2][2]->Glyph);break;
  case 0x0a:PutImage(lx1,ypos,CalcBtns[1][5]->Glyph);break;
  case 0x0b:PutImage(lx1,ypos,CalcBtns[2][5]->Glyph);break;
  case 0x0c:PutImage(lx1,ypos,CalcBtns[3][5]->Glyph);break;
  case 0x0d:PutImage(lx1,ypos,CalcBtns[4][5]->Glyph);break;
  case 0x0e:PutImage(lx1,ypos,CalcBtns[4][4]->Glyph);break;
  case 0x0f:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[4][4]->Picture->Bitmap);break;
  case 0x10:PutImage(lx1,ypos,CalcBtns[3][3]->Glyph);break;
  case 0x11:PutImage(lx1,ypos,CalcBtns[3][2]->Glyph);break;
  case 0x12:PutImage(lx1,ypos,CalcBtns[4][3]->Glyph);break;
  case 0x13:PutImage(lx1,ypos,CalcBtns[4][2]->Glyph);break;
  case 0x14:PutImage(lx1,ypos,CalcBtns[3][4]->Glyph);break;
  case 0x15:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[0][5]->Picture->Bitmap);break;
  case 0x16:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[0][4]->Picture->Bitmap);break;
  case 0x17:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][4]->Picture->Bitmap);break;
  case 0x18:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[2][4]->Picture->Bitmap);break;
  case 0x19:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[0][3]->Picture->Bitmap);break;
  case 0x1a:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][3]->Picture->Bitmap);break;
  case 0x1b:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[2][3]->Picture->Bitmap);break;
  case 0x1c:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[0][2]->Picture->Bitmap);break;
  case 0x1d:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][2]->Picture->Bitmap);break;
  case 0x1e:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[2][2]->Picture->Bitmap);break;
  case 0x20:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[3][3]->Picture->Bitmap);break;
  case 0x21:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[3][2]->Picture->Bitmap);break;
  case 0x22:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[4][3]->Picture->Bitmap);break;
  case 0x23:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[4][2]->Picture->Bitmap);break;
  case 0x24:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[3][4]->Picture->Bitmap);break;
  case 0x25:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][5]->Picture->Bitmap);break;
  case 0x26:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[3][3]->Picture->Bitmap);break;
  case 0x2a:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[2][4]->Picture->Bitmap);break;
  case 0x30:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[3][4]->Picture->Bitmap);break;
  case 0x31:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[0][3]->Picture->Bitmap);break;
  case 0x32:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[1][3]->Picture->Bitmap);break;
  case 0x33:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[2][3]->Picture->Bitmap);break;
  case 0x34:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[0][2]->Picture->Bitmap);break;
  case 0x35:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[1][2]->Picture->Bitmap);break;
  case 0x36:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[2][2]->Picture->Bitmap);break;
  case 0x37:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[1][5]->Picture->Bitmap);break;
  case 0x38:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[2][5]->Picture->Bitmap);break;
  case 0x39:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[3][5]->Picture->Bitmap);break;
  case 0x3a:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[4][5]->Picture->Bitmap);break;
  case 0x3b:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[4][4]->Picture->Bitmap);break;
  case 0x40:
  case 0x41:
  case 0x42:
  case 0x43:
  case 0x44:
  case 0x45:
  case 0x46:
  case 0x47:
  case 0x48:
  case 0x49:
  case 0x4a:
  case 0x4b:
  case 0x4c:
  case 0x4d:
  case 0x4e:
 	PutImage(lx1,ypos,CalcBtns[2][1]->Glyph);
 	PaintNum(com%16,lx2,ypos);
  break;
  case 0x50:PutImage(lx1,ypos,CalcBtns[4][0]->Glyph);break;
  case 0x51:PutImage(lx1,ypos,CalcBtns[3][1]->Glyph);break;
  case 0x52:PutImage(lx1,ypos,CalcBtns[3][0]->Glyph);break;
  case 0x53:PutImage(lx1,ypos,CalcBtns[4][1]->Glyph);break;
  case 0x54:PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);PutImage(lx2,ypos+dy,Blue[0][5]->Picture->Bitmap);break;
  case 0x57:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[4][0]->Picture->Bitmap);break;
  case 0x58:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[3][1]->Picture->Bitmap);break;
  case 0x59:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[3][0]->Picture->Bitmap);break;
  case 0x5a:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[4][1]->Picture->Bitmap);break;
  case 0x5b:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[2][1]->Picture->Bitmap);break;
  case 0x5c:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][0]->Picture->Bitmap);break;
  case 0x5d:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[1][1]->Picture->Bitmap);break;
  case 0x5e:PutImage(lx1,ypos,CalcBtns[0][0]->Glyph);PutImage(lx2,ypos+dy,Yellow[2][0]->Picture->Bitmap);break;
  case 0x60:
  case 0x61:
  case 0x62:
  case 0x63:
  case 0x64:
  case 0x65:
  case 0x66:
  case 0x67:
  case 0x68:
  case 0x69:
  case 0x6a:
  case 0x6b:
  case 0x6c:
  case 0x6d:
  case 0x6e:
 	PutImage(lx1,ypos,CalcBtns[1][1]->Glyph);
 	PaintNum(com%16,lx2,ypos);
  break;
  case 0x70:
  case 0x71:
  case 0x72:
  case 0x73:
  case 0x74:
  case 0x75:
  case 0x76:
  case 0x77:
  case 0x78:
  case 0x79:
  case 0x7a:
  case 0x7b:
  case 0x7c:
  case 0x7d:
  case 0x7e:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos+dy,Yellow[4][0]->Picture->Bitmap);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0x80:
  case 0x81:
  case 0x82:
  case 0x83:
  case 0x84:
  case 0x85:
  case 0x86:
  case 0x87:
  case 0x88:
  case 0x89:
  case 0x8a:
  case 0x8b:
  case 0x8c:
  case 0x8d:
  case 0x8e:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos,CalcBtns[3][1]->Glyph);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0x90:
  case 0x91:
  case 0x92:
  case 0x93:
  case 0x94:
  case 0x95:
  case 0x96:
  case 0x97:
  case 0x98:
  case 0x99:
  case 0x9a:
  case 0x9b:
  case 0x9c:
  case 0x9d:
  case 0x9e:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos+dy,Yellow[3][0]->Picture->Bitmap);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0xa0:
  case 0xa1:
  case 0xa2:
  case 0xa3:
  case 0xa4:
  case 0xa5:
  case 0xa6:
  case 0xa7:
  case 0xa8:
  case 0xa9:
  case 0xaa:
  case 0xab:
  case 0xac:
  case 0xad:
  case 0xae:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos,CalcBtns[4][1]->Glyph);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0xb0:
  case 0xb1:
  case 0xb2:
  case 0xb3:
  case 0xb4:
  case 0xb5:
  case 0xb6:
  case 0xb7:
  case 0xb8:
  case 0xb9:
  case 0xba:
  case 0xbb:
  case 0xbc:
  case 0xbd:
  case 0xbe:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos,CalcBtns[2][1]->Glyph);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0xc0:
  case 0xc1:
  case 0xc2:
  case 0xc3:
  case 0xc4:
  case 0xc5:
  case 0xc6:
  case 0xc7:
  case 0xc8:
  case 0xc9:
  case 0xca:
  case 0xcb:
  case 0xcc:
  case 0xcd:
  case 0xce:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos+dy,Yellow[1][0]->Picture->Bitmap);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0xd0:
  case 0xd1:
  case 0xd2:
  case 0xd3:
  case 0xd4:
  case 0xd5:
  case 0xd6:
  case 0xd7:
  case 0xd8:
  case 0xd9:
  case 0xda:
  case 0xdb:
  case 0xdc:
  case 0xdd:
  case 0xde:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos,CalcBtns[1][1]->Glyph);
 	PaintNum(com%16,lx3,ypos);
  break;
  case 0xe0:
  case 0xe1:
  case 0xe2:
  case 0xe3:
  case 0xe4:
  case 0xe5:
  case 0xe6:
  case 0xe7:
  case 0xe8:
  case 0xe9:
  case 0xea:
  case 0xeb:
  case 0xec:
  case 0xed:
  case 0xee:
 	PutImage(lx1,ypos,CalcBtns[0][1]->Glyph);
 	PutImage(lx2,ypos+dy,Yellow[2][0]->Picture->Bitmap);
 	PaintNum(com%16,lx3,ypos);
  break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintNum(int n,int x,int y)
{
 switch(n)
 {
	case 0:PutImage(x,y,CalcBtns[0][5]->Glyph);break;
	case 1:PutImage(x,y,CalcBtns[0][4]->Glyph);break;
	case 2:PutImage(x,y,CalcBtns[1][4]->Glyph);break;
	case 3:PutImage(x,y,CalcBtns[2][4]->Glyph);break;
	case 4:PutImage(x,y,CalcBtns[0][3]->Glyph);break;
	case 5:PutImage(x,y,CalcBtns[1][3]->Glyph);break;
	case 6:PutImage(x,y,CalcBtns[2][3]->Glyph);break;
	case 7:PutImage(x,y,CalcBtns[0][2]->Glyph);break;
	case 8:PutImage(x,y,CalcBtns[1][2]->Glyph);break;
	case 9:PutImage(x,y,CalcBtns[2][2]->Glyph);break;
	case 10:ProgList->Canvas->TextOut(x+10,y+3,"A");break;
	case 11:ProgList->Canvas->TextOut(x+10,y+3,"B");break;
	case 12:ProgList->Canvas->TextOut(x+10,y+3,"C");break;
	case 13:ProgList->Canvas->TextOut(x+10,y+3,"D");break;
	case 14:ProgList->Canvas->TextOut(x+10,y+3,"E");break;

 }
}
//----------------------------------------------------------------------------
void __fastcall TForm1::PutImage(int x,int y,Graphics::TBitmap* Bitmap,TCanvas* Canvas)
{
 if(Canvas==NULL)Canvas=ProgList->Canvas;
 TRect Dest,Source;
 Source.Left=0;
 Source.Top=0;
 Source.Right=Bitmap->Width;
 Source.Bottom=Bitmap->Height;
 Dest.Left=x;
 Dest.Top=y;
 Dest.Right=x+Bitmap->Width;
 Dest.Bottom=y+Bitmap->Height;
 Canvas->BrushCopy(Dest,Bitmap,Source,clFuchsia);
}
//-------------------------------------------------------------------
void __fastcall TForm1::ProgListClick(TObject *Sender)
{
 calc.prgstep=ProgList->ItemIndex;
 indi.refresh();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ProgListKeyPress(TObject *Sender, char &Key)
{
 ProgListClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
 calc.run();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenButtClick(TObject *Sender)
{
 if(File.saved==false)
  {
   File.ask=false;
   if(Application->MessageBox("   ?","  ",MB_YESNO|MB_ICONQUESTION)==IDYES)
   {
    File.Save();
   }
  }
 CurFile->Caption=FileName->Text;
 File.Open();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveButtClick(TObject *Sender)
{
 if(FileName->Text.LowerCase().Pos(".mk")==0)
  FileName->Text=FileName->Text+".mk";
 CurFile->Caption=FileName->Text; 
 File.Save();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileNameChange(TObject *Sender)
{
 //if(FileName->Modified==false)return;
 if(FileExists(FileName->Text))
 {
  OpenButt->Enabled=true;
  if(File.saved==false)
  {
   File.ask=false;
   if(Application->MessageBox("   ?","  ",MB_YESNO|MB_ICONQUESTION)==IDYES)
   {
    File.Save();
   }
  }
 }
 else
  OpenButt->Enabled=false;
 //if(FileExists(FileName->Text))
 // FileListBox->ApplyFilePath(FileName->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileListBoxDblClick(TObject *Sender)
{
 OpenButt->Click();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::KeysComboBoxDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
 if(State.Contains(odSelected))
  KeysComboBox->Canvas->Brush->Color=clHighlight;
 else
  KeysComboBox->Canvas->Brush->Color=KeysComboBox->Color;
 KeysComboBox->Canvas->FillRect(Rect);
 PutImage(Rect.Left,Rect.Top,CalcBtns[Index%5][Index/5]->Glyph,KeysComboBox->Canvas);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::KeysComboBoxChange(TObject *Sender)
{
 KeysHotKey->HotKey=HotKeys[KeysComboBox->ItemIndex][0];
 KeysHotKey2->HotKey=HotKeys[KeysComboBox->ItemIndex][1];
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::KeysHotKeyExit(TObject *Sender)
{
 HotKeys[KeysComboBox->ItemIndex][((THotKey*)Sender)->Tag]=((THotKey*)Sender)->HotKey;
 Editing=false;
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EnterEdit(TObject *Sender)
{
 Editing=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExitEdit(TObject *Sender)
{
 Editing=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 if(!Editing)
  for(int i=0;i<5;i++)
   for(int j=0;j<6;j++)
   {
    if(HotKeys[i+j*5][0]==Key||HotKeys[i+j*5][1]==Key)
    {
     CalcBtns[i][j]->GroupIndex=2;
     CalcBtns[i][j]->Down=true;
     CalcBtns[i][j]->Click();
    }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 if(!Editing)
 for(int i=0;i<5;i++)
   for(int j=0;j<6;j++)
   {
    if(HotKeys[i+j*5][0]==Key||HotKeys[i+j*5][1]==Key)
    {
     CalcBtns[i][j]->Down=false;
     CalcBtns[i][j]->GroupIndex=0;
    }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PRGLabelClick(TObject *Sender)
{
 calc.PRG=!calc.PRG;
 indi.refresh();
 FreshMenu();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::KeysRadioClick(TObject *Sender)
{
 AnsiString A;
 switch(KeysRadio->ItemIndex)
 {
  case 0:
   A="";
  break;
  case 1:
   A="A";
  break;
 }
 CalcBtns[2][1]->Glyph->LoadFromResourceName((int)HInstance,A+"M21");
 CalcBtns[1][1]->Glyph->LoadFromResourceName((int)HInstance,A+"M11");
 CalcBtns[3][4]->Glyph->LoadFromResourceName((int)HInstance,A+"M34");
 CalcBtns[4][4]->Glyph->LoadFromResourceName((int)HInstance,A+"M44");
 Yellow[0][3]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"Y03");
 Yellow[1][3]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"Y13");
 Yellow[2][3]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"Y23");
 Blue[2][3]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"B23");
 Blue[3][3]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"B33");
 Blue[2][4]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"B24");
 Blue[3][4]->Picture->Bitmap->LoadFromResourceName((int)HInstance,A+"B34");
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IndiRadioClick(TObject *Sender)
{
 switch(IndiRadio->ItemIndex)
 {
  case 0:
   Indi[0]->Symbols->Strings[10]="G";
   Indi[0]->Symbols->Strings[11]="DEF";
   Indi[0]->Symbols->Strings[13]="AEF";
  break;
  case 1:
   Indi[0]->Symbols->Strings[10]="ABCEFG";
   Indi[0]->Symbols->Strings[11]="CDEFG";
   Indi[0]->Symbols->Strings[13]="BCDEG";
  break;
 }
 for(int i=1;i<12;i++)
  Indi[i]->Symbols=Indi[0]->Symbols;
 indi.refresh();
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AppIdle(TObject* Sender,bool& Done)
{
 if(SpeedUpDown->Position!=0)
 {
  Done=true;
 }
 else
 {
  calc.run();
 }
}
//-----------------------------------------------------------------
void __fastcall TForm1::SpeedUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
 if(SpeedUpDown->Position==0)
 {
  Timer1->Enabled=false;
 }
 else
 {
  Timer1->Interval=SpeedUpDown->Position;
  Timer1->Enabled=true;
 }
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnTrackBarChange(TObject *Sender)
{
 if(OnTrackBar->Position==0)
 {
  OnTrackBar->Position=1;
  if(File.saved==false)
   if(Application->MessageBox("   ?","  ",MB_YESNO|MB_ICONQUESTION)==IDNO)return;
  calc.totreset();
  indi.refresh();
  FreshMenu();
  ProgList->Refresh();
  FileDescr->Clear();
  ProgDescr->Clear();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShortcutButtonClick(TObject *Sender)
{  //        Win32 Programmer's Reference
 /*HRESULT hres;
 IShellLink* psl;
 hres=CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&psl);
 if(SUCCEEDED(hres))
 {
  IPersistFile* ppf;
  psl->SetPath(Application->ExeName.c_str());
  psl->SetDescription("MK-61");
  hres = psl->QueryInterface(IID_IPersistFile,&((void*)ppf));
  if (SUCCEEDED(hres))
  {
   wchar_t wsz[12];
   MultiByteToWideChar(CP_ACP, 0, "Desktop", -1, wsz, 12);
   hres = ppf->Save(wsz , TRUE);
   ppf->Release();
  }
  psl->Release();
 }               */
/* TOleContainer* Ole;
 Ole=new TOleContainer(this);
 Ole->Parent=OpsTab;
 Ole->Visible=false;
 Ole->CreateLinkToFile(Application->ExeName,true);
 Ole->SaveToFile("MK-61.lnk");
 delete Ole;*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileListBoxChange(TObject *Sender)
{
 FileDescr->Lines->Text=File.GetDescr();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveOpsButtonClick(TObject *Sender)
{
 AnsiString temp;
 temp=CurFile->Caption;
 CurFile->Caption=ExtractFileDir(Application->ExeName)+"\\MK61.mk";
 SaveButt->Click();
 CurFile->Caption=temp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MainPanelClick(TObject *Sender)
{
 ActiveControl=MainPanel;//   
}
//---------------------------------------------------------------------------
void TForm1::ShowHelp(const char* HelpName)
{
 static char pre[20];
 if(!strcmp(pre,HelpName))return;
 strcpy(pre,HelpName);
 if(MenuPages->ActivePage!=HelpTab)return;
 HelpMemo->Lines->Clear();
 if(HelpFile==NULL)return;
 char Help[20];
 Help[0]='[';
 Help[1]=0;
 strcat(Help,HelpName);
 strcat(Help,"]\n");
 fseek(HelpFile,0,0);
 char tmp[82];
 do
 {
  fgets(tmp,80,HelpFile);
 }
 while(!feof(HelpFile)&&strcmp(tmp,Help));
 while(!feof(HelpFile))
 {
  fgets(tmp,80,HelpFile);
  if(tmp[0]=='[')break;
  HelpMemo->Lines->Text=HelpMemo->Lines->Text+tmp;
 }
}
//----------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 fclose(HelpFile);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label38MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 ShowHelp("ABOUT");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label39MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 ShowHelp("CALC");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
 int x,y;
 x=((TBitBtn*)Sender)->Tag%5;
 y=((TBitBtn*)Sender)->Tag/5;
 char tmp[20];
 sprintf(tmp,"B%i%i",x,y);
 ShowHelp(tmp);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuPagesMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if(X<43) ShowHelp("FILE");
 else if(X<97) ShowHelp("MEMORY");
 else if(X<162) ShowHelp("OPTIONS");
 else if(X<217) ShowHelp("DEFAULT");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileListBoxKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 if(Key==46)//Del
 {
  if(Application->MessageBox(" ?","",MB_YESNO|MB_ICONQUESTION)==6)
  {
   DeleteFile(FileListBox->Items->Strings[FileListBox->ItemIndex]);
   FileListBox->Update();
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 if(File.saved==false)
  if(Application->MessageBox("   ?","  ",MB_YESNO|MB_ICONQUESTION)==IDYES)
  {
   File.Save();
   if(File.saved==false)Action=caNone;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label2MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
 ShowHelp("ON_OFF");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label4MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
 ShowHelp("R_G");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IndiPanelMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 ShowHelp("INDI");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label40MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 ShowHelp("PROG");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DegRadTrackBarChange(TObject *Sender)
{
 File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileDescrChange(TObject *Sender)
{
 if(FileDescr->Modified)
  File.saved=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ProgDescrChange(TObject *Sender)
{
 if(ProgDescr->Modified)
  File.saved=false;
}
//---------------------------------------------------------------------------

