//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <SegIndi.h>
#include <FileCtrl.hpp>
#include <Graphics.hpp>
#include "CSPIN.h"
#include <shlobj.h>
#include <stdio.h>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TPanel *BasePanel;
        TPanel *IndiPanel;
        TPanel *MainPanel;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TTrackBar *OnTrackBar;
        TTrackBar *DegRadTrackBar;
        TPanel *MenuPanel;
        TPageControl *MenuPages;
        TTabSheet *FileTab;
        TTabSheet *MemoTab;
        TTabSheet *OpsTab;
        TTabSheet *HelpTab;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TDirectoryListBox *DirListBox;
        TFileListBox *FileListBox;
        TDriveComboBox *DriveCombo;
        TLabel *Label11;
        TEdit *FileName;
        TMemo *FileDescr;
        TLabel *Label12;
        TLabel *Label13;
        TButton *OpenButt;
        TButton *SaveButt;
        TButton *ExitButt;
        TLabel *Label14;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label17;
        TLabel *Label18;
        TLabel *Label19;
        TEdit *EditT;
        TEdit *EditZ;
        TEdit *EditY;
        TEdit *EditX;
        TEdit *EditX1;
        TLabel *Label20;
        TLabel *Label21;
        TLabel *Label22;
        TLabel *Label23;
        TLabel *Label24;
        TLabel *Label25;
        TLabel *Label26;
        TLabel *Label27;
        TLabel *Label28;
        TLabel *Label29;
        TLabel *Label30;
        TLabel *Label31;
        TLabel *Label32;
        TLabel *Label33;
        TLabel *Label34;
        TLabel *Label35;
        TListBox *ProgList;
        TLabel *Label36;
        TLabel *Label37;
        TMemo *ProgDescr;
        TTimer *Timer1;
        TRadioGroup *KeysRadio;
        TRadioGroup *IndiRadio;
        TGroupBox *KeysGroup;
        TGroupBox *SpeedGroup;
        TPanel *UpPanel;
        TSpeedButton *CloseButton;
        TSpeedButton *MenuButton;
        TSpeedButton *MinimizeButton;
        TLabel *PRGLabel;
        TLabel *FKLabel;
        THotKey *KeysHotKey;
        TComboBox *KeysComboBox;
        TButton *SaveOpsButton;
        TLabel *Label41;
        TEdit *SpeedEdit;
        TUpDown *SpeedUpDown;
        TGroupBox *SystemGroup;
        TButton *ShortcutButton;
        TButton *AssignButton;
        THotKey *KeysHotKey2;
        TMemo *HelpMemo;
        TLabel *Label38;
        TLabel *Label39;
        TLabel *Label40;
        TLabel *CurFile;
        void __fastcall CloseButtonClick(TObject *Sender);
        void __fastcall MinimizeButtonClick(TObject *Sender);
        void __fastcall UpPanelMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall UpPanelMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall MenuButtonClick(TObject *Sender);
        void __fastcall UpPanelDblClick(TObject *Sender);
        void __fastcall UpPanelMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ExitButtClick(TObject *Sender);
        void __fastcall EditTChange(TObject *Sender);
        void __fastcall EditZChange(TObject *Sender);
        void __fastcall EditYChange(TObject *Sender);
        void __fastcall EditXChange(TObject *Sender);
        void __fastcall EditX1Change(TObject *Sender);
        void __fastcall ProgListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ProgListClick(TObject *Sender);
        void __fastcall ProgListKeyPress(TObject *Sender, char &Key);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall OpenButtClick(TObject *Sender);
        void __fastcall SaveButtClick(TObject *Sender);
        void __fastcall FileNameChange(TObject *Sender);
        void __fastcall FileListBoxDblClick(TObject *Sender);
        void __fastcall KeysComboBoxDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall KeysComboBoxChange(TObject *Sender);
        void __fastcall KeysHotKeyExit(TObject *Sender);
        void __fastcall EnterEdit(TObject *Sender);
        void __fastcall ExitEdit(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall PRGLabelClick(TObject *Sender);
        void __fastcall KeysRadioClick(TObject *Sender);
        void __fastcall IndiRadioClick(TObject *Sender);
        void __fastcall SpeedUpDownClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall OnTrackBarChange(TObject *Sender);
        void __fastcall ShortcutButtonClick(TObject *Sender);
        void __fastcall FileListBoxChange(TObject *Sender);
        void __fastcall SaveOpsButtonClick(TObject *Sender);
        void __fastcall MainPanelClick(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall Label38MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Label39MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall MenuPagesMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall FileListBoxKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Label2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Label4MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall IndiPanelMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Label40MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall DegRadTrackBarChange(TObject *Sender);
        void __fastcall FileDescrChange(TObject *Sender);
        void __fastcall ProgDescrChange(TObject *Sender);
private:	// User declarations
        int X4move,Y4move,preY4move,preX4move;
        void __fastcall MemChange(TObject* Sender);
        bool Freshing; //   (  )
        bool DblClicking; //   ( )
        bool Editing; //  .-.   (   )
        void __fastcall PaintNum(int,int,int);
        void __fastcall PutImage(int x,int y,Graphics::TBitmap *Bitmap,TCanvas* Canvas=NULL);
        void __fastcall AppIdle(TObject* Sender,bool& Done);
        void __fastcall BtnMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
        FILE* HelpFile;
        void ShowHelp(const char*);
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        TSpeedButton *CalcBtns[5][6];
        TImage *Yellow[5][6];
        TImage *Blue[5][6];
        TSegIndi *Indi[12];
        TEdit *Mem[15];
        void __fastcall FreshMenu();
        double __fastcall Str2Float(AnsiString Str); 
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
extern TShortCut HotKeys[30][2];
//---------------------------------------------------------------------------
#endif
