//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"

filework File;

const char tags[6][16]={"[PROGRAM]\n","[STACK]\n","[REGISTERS]\n","[FILE_DESCR]\n","[PROG_DESCR]\n","[OPTIONS]\n"};

filework::filework()
{
 ask=true;
 saved=true;
}
//----------------------------------------------------------------------------
void __fastcall filework::Open()
{
 FILE *F;
 F=fopen(Form1->CurFile->Caption.c_str(),"rt");
 if(!F)
 {
  if(ExtractFileName(Form1->CurFile->Caption)=="MK61.mk")return;
  Application->MessageBox("  ."," .",MB_ICONERROR);
  return;
 }
 Form1->FileDescr->Clear();
 Form1->ProgDescr->Clear();
 bool done;
 char str[80];
 int i=-1,j;
 int tag=-1;
 for(j=0;j<6;j++)
 {
  if(feof(F))break;
  tag=-1;
  do
  {
   fgets(str,80,F);
   for(i=0;i<6;i++)
    if(!strcmp(str,tags[i])){tag=i;break;}
  }
  while(tag==-1&&!feof(F));
  switch(tag)
  {
   case 0:
   for(i=0;i<105;i++)
   {
    fscanf(F,"%x",&calc.prog[i]);
    if(ferror(F))break;
   }
   break;
   case 1:
   for(i=0;i<5;i++)
   {
    fgets(str,80,F);
    calc.stack[i]=atof(str);
    if(ferror(F))break;
   }
   break;
   case 2:
   for(i=0;i<15;i++)
   {
    fgets(str,80,F);
    calc.mem[i]=atof(str);
    if(ferror(F))break;
   }
   break;
   case 3:
    done=false;
    while(!done)
    {
     fgets(str,80,F);
     for(i=0;i<6;i++)
      if(!strcmp(str,tags[i]))
      {
       fseek(F,ftell(F)-strlen(tags[i])-1,0);   //<-----------
       //fseek(F,-strlen(tags[i]),1);
       done=true;
       break;
      }
     if(ferror(F))done=true;
     if(!done)Form1->FileDescr->Lines->Text=Form1->FileDescr->Lines->Text+str;
    }
   break;
   case 4:
    done=false;
    while(!done)
    {
     fgets(str,80,F);
     for(i=0;i<6;i++)
      if(!strcmp(str,tags[i]))
      {
       fseek(F,ftell(F)-strlen(tags[i])-1,0);
       done=true;
       break;
      }
     if(ferror(F))done=true;
     if(!done)Form1->ProgDescr->Lines->Text=Form1->ProgDescr->Lines->Text+str;
    }
   break;
   case 5:
    fgets(str,80,F);
    Form1->KeysRadio->ItemIndex=atoi(str);
    fgets(str,80,F);
    Form1->IndiRadio->ItemIndex=atoi(str);
    for(i=0;i<30;i++)
    {
     fgets(str,80,F);
     HotKeys[i][0]=atoi(str);
     fgets(str,80,F);
     HotKeys[i][1]=atoi(str);
    }
    fgets(str,80,F);
    Form1->SpeedUpDown->Position=atoi(str);
    fgets(str,80,F);
    Form1->DegRadTrackBar->Position=atoi(str);
   break;
  }
 }
 fclose(F);
 calc.numindi();
 indi.refresh();
 Form1->FreshMenu();
 Form1->MenuPages->ActivePage=Form1->MemoTab;
 saved=true;
}
//----------------------------------------------------------------
void __fastcall filework::Save()
{
 bool needupdate=!FileExists(Form1->CurFile->Caption);
 if(ask&&!needupdate)
  if(Application->MessageBox("  ?","  ",MB_YESNO|MB_ICONQUESTION)==IDNO)
   return;
 FILE *F;
 F=fopen(Form1->CurFile->Caption.c_str(),"wt");
 if(!F)
 {
  Application->MessageBox("  ."," .",MB_ICONERROR);
  return;
 }
 int i;
 fprintf(F,"%s",tags[3]);//  
 //fprintf(F,"%s",(Form1->FileDescr->Lines->Text.TrimRight()+"\n").c_str());
 for(i=0;i<Form1->FileDescr->Lines->Count;i++)
  fprintf(F,"%s\n",(Form1->FileDescr->Lines->Strings[i]).c_str());
 fprintf(F,"%s",tags[4]);//  
 //fprintf(F,"%s",(Form1->ProgDescr->Lines->Text.TrimRight()+"\n").c_str());
 for(i=0;i<Form1->ProgDescr->Lines->Count;i++)
  fprintf(F,"%s\n",(Form1->ProgDescr->Lines->Strings[i]).c_str());
 fprintf(F,"%s",tags[0]);// 
 for(i=0;i<105;i++)
  fprintf(F,"%x\n",calc.prog[i]);
 fprintf(F,"%s",tags[1]);// 
 for(i=0;i<5;i++)
  fprintf(F,"%g\n",calc.stack[i]);
 fprintf(F,"%s",tags[2]);//  
 for(i=0;i<15;i++)
  fprintf(F,"%g\n",calc.mem[i]);
 fprintf(F,"%s",tags[5]);// 
 fprintf(F,"%i\n",Form1->KeysRadio->ItemIndex);
 fprintf(F,"%i\n",Form1->IndiRadio->ItemIndex);
 for(i=0;i<30;i++)
  fprintf(F,"%i\n%i\n",HotKeys[i][0],HotKeys[i][1]);
 fprintf(F,"%i\n",Form1->SpeedUpDown->Position);
 fprintf(F,"%i\n",Form1->DegRadTrackBar->Position);
 fclose(F);
 if(needupdate)Form1->FileListBox->Update();
 ask=true;
 saved=true;
}
//-------------------------------------------------------------------
AnsiString __fastcall filework::GetDescr()
{
 AnsiString Ret;
 FILE *F;
 bool done;
 int i;
 F=fopen(Form1->FileName->Text.c_str(),"rt");
 if(!F) return "";
 char str[80];
 do
  fgets(str,80,F);
 while(strcmp(str,tags[3])&&!feof(F));
 done=false;
 while(!done)
 {
  fgets(str,80,F);
  for(i=0;i<6;i++)
  if(!strcmp(str,tags[i]))
  {
   done=true;
   break;
  }
  if(ferror(F)||feof(F))done=true;
  if(!done)Ret=Ret+str;
 }
 fclose(F);
 return Ret;
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
